> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.itential.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.itential.com/_mcp/server.

# Create a config spec

POST https://example.itential.io/configuration_manager/config_specs
Content-Type: application/json

Creates a new Config Spec.

Reference: https://docs.itential.com/itential-platform/6/api-reference/configuration-manager/create-config-spec

## Authentication

- `Authorization` header (basic auth, required) — Basic authentication of the form `Basic <base64(username:password)>`.

## Request

### Body (application/json)

This endpoint expects an object.

- `deviceType` (string, optional)
- `data` (object, optional)
  - `template` (string, optional)
  - `variables` (string, optional)

## Response

### 200

configSpec

- `id` (string, optional)
- `deviceType` (string, optional)
- `lines` (list of object, optional)
  - `id` (string, optional)
  - `evalMode` (enum, optional)
    - Allowed values: `required`, `disallowed`, `ignored`, `optional`
  - `severity` (enum, optional)
    - Allowed values: `error`, `warning`, `info`
  - `words` (list of object, optional)
    - `type` (enum, optional)
      - Allowed values: `literal`, `regex`, `variable`
    - `value` (string, optional)
  - `lines` (list of any, optional)
- `created` (string, optional)
- `createdBy` (string, optional)
- `lastUpdated` (string, optional)
- `lastUpdatedBy` (string, optional)

## Errors

### 500 Internal Server Error

Error response from API

- `any`

## Examples

**Request**

```json
{}
```

**Response**

```json
{
  "id": "5c35355dbebaa82eaf8113f0",
  "deviceType": "cisco-ios",
  "lines": [
    {
      "id": "5c353f69d085d85c",
      "evalMode": "required",
      "severity": "error",
      "words": [
        {
          "type": "literal",
          "value": "<token from configuration> or <regex pattern> or <variable name>"
        }
      ],
      "lines": [
        null
      ]
    }
  ],
  "created": "2019-04-12T14:42:47.958Z",
  "createdBy": "5c35355dbebaa82eaf8113f0",
  "lastUpdated": "2019-04-12T14:42:47.958Z",
  "lastUpdatedBy": "5c35355dbebaa82eaf8113f0"
}
```

**SDK Code**

```python
import requests

url = "https://example.itential.io/configuration_manager/config_specs"

payload = {}
headers = {"Content-Type": "application/json"}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://example.itential.io/configuration_manager/config_specs';
const options = {method: 'POST', headers: {'Content-Type': 'application/json'}, body: '{}'};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://example.itential.io/configuration_manager/config_specs"

	payload := strings.NewReader("{}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://example.itential.io/configuration_manager/config_specs")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Content-Type"] = 'application/json'
request.body = "{}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://example.itential.io/configuration_manager/config_specs")
  .header("Content-Type", "application/json")
  .body("{}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://example.itential.io/configuration_manager/config_specs', [
  'body' => '{}',
  'headers' => [
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://example.itential.io/configuration_manager/config_specs");
var request = new RestRequest(Method.POST);
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = ["Content-Type": "application/json"]
let parameters = [] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://example.itential.io/configuration_manager/config_specs")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```